# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.


proc add_main_menu { menubar } {
global UI ac_platform tcl_platform tcl_version
global prefs_recentfiles0 prefs_recentfiles1 prefs_recentfiles2 prefs_recentfiles3


# FILE MENU
    set UI(menu_file) [menu $menubar.file -tearoff 0 ]

    # export menu - part of file menu
    set UI(menu_export) [menu $menubar.file.export -tearoff 0 ]

    $menubar.file add command -label "New..." -command "menu_clear" -accelerator [accel Ctrl+N ] -underline 0
    $menubar.file add command -label "Open..." -command { menu_open ""  } -accelerator [accel Ctrl+O] -underline 0


    # Recent file menu
    set UI(menu_recent) [menu $menubar.file.recent -tearoff 0]

    $menubar.file add cascade -label "Open Recent" -menu $UI(menu_recent) -underline 5
    
    $UI(menu_recent) add command -label $prefs_recentfiles0 -command { if { $prefs_recentfiles0 != ""} { menu_open $prefs_recentfiles0} }
	$UI(menu_recent) add command -label $prefs_recentfiles1 -command { if { $prefs_recentfiles1 != ""} { menu_open $prefs_recentfiles1} }
    $UI(menu_recent) add command -label $prefs_recentfiles2 -command { if { $prefs_recentfiles2 != ""} { menu_open $prefs_recentfiles2} }
    $UI(menu_recent) add command -label $prefs_recentfiles3 -command { if { $prefs_recentfiles3 != ""} { menu_open $prefs_recentfiles3} }


    $menubar.file add separator
    $menubar.file add command -label "Merge..." -command { menu_merge } 
# used for minimize on Mac #-accelerator [accel Ctrl+M] -underline 0

#   $menubar.file add separator

    $menubar.file add command -label "Import..." -command {menu_import } -accelerator [accel Ctrl+I] -underline 0
    $menubar.file add cascade -label "Export" -menu $UI(menu_export) -underline 0
    $menubar.file add cascade -label "Export Selection..." -command menu_export_selected

	$menubar.file add separator
$menubar.file add command -label "Object Library..." -command { obj_lib_dlg } -underline 7
    $menubar.file add separator

    $menubar.file add command -label "Save" -command "menu_save_last" -underline 0  -accelerator [accel Ctrl+S]
    $menubar.file add command -label "Save As..." -command "menu_save_ac" -underline 5
# -accelerator [accel Ctrl+Shift+S] 
    $menubar.file add command -label "Save Selection..." -command "menu_save_selection" -underline 7
    $menubar.file add separator
		# only add Print under Windows
	if { $tcl_platform(platform) == "windows" } {
		$menubar.file add command -label "Print Setup..." -command "ac3d windows_print_setup_dialog ."
		$menubar.file add command -label "Print..." -command "dialog_windows_print" -underline 1 -accelerator [accel Ctrl+P]
		$menubar.file add separator

	}

    $menubar.file add command -label "Settings..." -command "show_settings" -underline 2
#    $menubar.file add separator


if {$ac_platform != "Mac" } {
	$menubar.file add separator
    $menubar.file add command -label "Exit..." -command "menu_quit" -underline 1
}


	set filehelplist { "Clear everything" "Open an AC3D file" "" "" "Insert a model" \
		"Insert a non AC3D format file" "Save the model in a different format" \
		"Open a dialog for exporting the selected/all in any supported format" \
		"" "Open the object library" \
		"" "Save the current model" \
        "Save the current model with a new name" "Save selection as an AC3D file" "" \
        }

	if { $tcl_platform(platform) == "windows" } {
		lappend filehelplist "Adjust printer settings" "Print a view window" ""
	}

    lappend filehelplist  "edit preferences" "" "Exit AC3D" 

	add_menu_balloons $menubar.file $filehelplist




# edit menu
    menubutton $menubar.edit -text "Edit" -menu $menubar.edit.menu -underline 0
    menu $menubar.edit.menu -tearoff 0
	set UI(menu_edit) $menubar.edit.menu
    $menubar.edit.menu add command -label "Undo" -command "ac3d undo" -accelerator [accel Ctrl+Z] -underline 0
    $menubar.edit.menu add command -label "Redo" -command "ac3d redo" -accelerator [accel Ctrl+Y] -underline 0
    $menubar.edit.menu add separator
    $menubar.edit.menu add command -label "Cut" -command "ac3d clipboard_cut" -accelerator [accel Ctrl+X]  -underline 2
    $menubar.edit.menu add command -label "Copy" -command "ac3d clipboard_copy" -accelerator [accel Ctrl+C]  -underline 0
    $menubar.edit.menu add command -label "Paste" -command "ac3d clipboard_paste" -accelerator [accel Ctrl+V]  -underline 0
    $menubar.edit.menu add command -label "Duplicate" -command "ac3d duplicate" -accelerator [accel Ctrl+D]  -underline 0

    $menubar.edit.menu add separator
    $menubar.edit.menu add command -label "Select All" -command "ac3d select_all" -accelerator [accel Ctrl+A]  -underline 7
    $menubar.edit.menu add command -label "Select Nothing" -command "ac3d clear_selection" -accelerator [accel Ctrl+Shift+A] -underline 7


	$menubar.edit.menu add cascade -label "Select Vertices" -menu .selectverticessmenu -underline 0
    menu .selectverticessmenu -tearoff 0
    .selectverticessmenu add command -label "Boundary" -command "ac3d select_boundary_vertices" -underline 0
    .selectverticessmenu add command -label "Outer" -command "ac3d select_outer_vertices" -underline 0
    .selectverticessmenu add command -label "Whole Surfaces" -command "ac3d select_part_selected_surfaces" -underline 0

    add_menu_balloons $menubar.edit.menu.selectverticessmenu { \
		"from the current selection, select only vertices that are on boundary edges" \
		"select only the outermost vertices of the current selection" \
		"select any whole surfaces that are already part selected"\
		}
		
	$menubar.edit.menu add cascade -label "Select Surfaces" -menu .selectsurfacesmenu -underline 0

    menu .selectsurfacesmenu -tearoff 0
    .selectsurfacesmenu add command -label "connected" -command "ac3d select_surfaces_connected"
    .selectsurfacesmenu add command -label "non-planar" -command "ac3d select_surfaces_by_type nonplanar"
	.selectsurfacesmenu add command -label "planar" -command "ac3d select_surfaces_by_type planar"
	.selectsurfacesmenu add command -label "triangle" -command "ac3d select_surfaces_by_type triangle"
	.selectsurfacesmenu add command -label "quad" -command "ac3d select_surfaces_by_type quad"
    .selectsurfacesmenu add command -label "invalid poly" -command "ac3d select_surfaces_by_type invalidpoly"
    .selectsurfacesmenu add command -label "> 4 vertices" -command "ac3d select_surfaces_by_type morethan4vertices"
    .selectsurfacesmenu add command -label "with bad triangulation" -command "ac3d select_surfaces_by_type badtriangulation"
	.selectsurfacesmenu add command -label "line" -command "ac3d select_surfaces_by_type line"
	.selectsurfacesmenu add command -label "polyline" -command "ac3d select_surfaces_by_type closedline"
	.selectsurfacesmenu add command -label "polygon" -command "ac3d select_surfaces_by_type polygon"
	.selectsurfacesmenu add command -label "with degenerate UVs" -command "ac3d select_surfaces_by_type degenerateuvs"

    add_menu_balloons $menubar.edit.menu.selectsurfacesmenu { \
		"select connected surfaces" \
		"select non-planar surfaces" \
		"select planar surfaces" \
		"select triangles" \
		"select quads (four vertices)" \
		"select polys with 1 or 2 vertices" \
		"select polys with > 4 vertices" \
		"select polygons that failed to triangulate (marked with red outline, usually with edges crossing)" \
		"select only lines" \
		"select only polylines" \
		"select only polygons" \
		"select surfaces with texture coors that do not map to a valid area" }

    $menubar.edit.menu add command -label "Select Loop" -command "ac3d select_loop" -underline 7 -accelerator [accel l]

    $menubar.edit.menu add command -label "Select/Unselect Objects by Name..." -command "dialog_select_by_name"  -underline 19
    
    $menubar.edit.menu add separator
    $menubar.edit.menu add command -label "Group" -command "ac3d group"  -underline 0 -accelerator [accel Ctrl+G]
    $menubar.edit.menu add command -label "Ungroup" -command "ac3d ungroup"  -underline 3 -accelerator [accel Ctrl+Shift+G]



    $menubar.edit.menu add separator
    $menubar.edit.menu add command -label "Delete" -command "ac3d delete" -accelerator [accel Delete ]

	if { $tcl_platform(platform) == "windows" } {
		$menubar.edit.menu add separator
		$menubar.edit.menu add command -label "Copy 3D View to Windows Clipboard" -command "update; ac3d copy_3d_win_to_clipboard"
	}

	if { $ac_platform == "Mac" } {
		$menubar.edit.menu add separator
		$menubar.edit.menu add command -label "Copy 3D View to Mac Clipboard" -command "update; ac3d copy_3d_win_to_clipboard"
	}

    add_menu_balloons $menubar.edit.menu { \
        "undo this operation" \
		"redo what was undone (also Ctrl+Shift+Z)" \
        "" \
        "cut selected to the AC3D clipboard" \
        "copy selected to the AC3D clipboard" \
        "paste the AC3D clipboard" \
        "make another copy of the selected" \
        "" \
        "select everything" \
        "clear the selection" \
		"select vertices according to some criteria" \
		"select surfaces according to some criteria" \
		"select a loop of vertices/surfaces" \
		"select or unselect objects by entering their names" \
        "" \
		"Group selected objects" \
		"Ungroup selected objects" \
		""\
	    "delete selected" \
		"" \
		"Copy the image in the 3D window to the Windows clipboard" }


# View menu
    menubutton $menubar.view -text "Views" -menu $menubar.view.menu -underline 0
    menu $menubar.view.menu -tearoff 0
	set UI(menu_view) $menubar.view.menu
#    $menubar.view.menu add command -label "Zoom in" -command "ac3d zoom_in" -accelerator [accel z] -underline 5
#    $menubar.view.menu add command -label "Zoom out" -command "ac3d zoom_out" -accelerator [accel x] -underline 5
    $menubar.view.menu add command -label "Fit All" -command "ac3d fit_all" -accelerator [accel Ctrl+Shift+F] -underline 4
    $menubar.view.menu add command -label "Fit Selection" -command "ac3d fit_selected_all" -accelerator [accel Ctrl+F] -underline 0
    $menubar.view.menu add command -label "Look at Selection" -command "ac3d goto_selected_all" -underline 0
    $menubar.view.menu add separator
#	$menubar.view.menu add cascade -label "Background image" -menu $menubar.view.menu.bgimage -underline 0

    menu $menubar.view.menu.bgimage -tearoff 0
    $menubar.view.menu.bgimage add cascade -label "Set" -menu $menubar.view.menu.bgimage.set -underline 0
    $menubar.view.menu.bgimage add cascade -label "Clear" -menu $menubar.view.menu.bgimage.clear -underline 0




    menu $menubar.view.menu.bgimage.set -tearoff 0
    $menubar.view.menu.bgimage.set add command -label "top-left" -command "ac3d file_select_background_image 0"
    $menubar.view.menu.bgimage.set add command -label "top-right" -command "ac3d file_select_background_image 1"
    $menubar.view.menu.bgimage.set add command -label "bottom-left" -command "ac3d file_select_background_image 2"
    $menubar.view.menu.bgimage.set add command -label "bottom-right" -command "ac3d file_select_background_image 3"

	$menubar.view.menu.bgimage.set add command -label "All" -command "ac3d file_select_background_image -1"

    menu $menubar.view.menu.bgimage.clear -tearoff 0
    $menubar.view.menu.bgimage.clear add command -label "top-left" -command "ac3d clear_background_image 0"
    $menubar.view.menu.bgimage.clear add command -label "top-right" -command "ac3d clear_background_image 1"
    $menubar.view.menu.bgimage.clear add command -label "bottom-left" -command "ac3d clear_background_image 2"
    $menubar.view.menu.bgimage.clear add command -label "bottom-right" -command "ac3d clear_background_image 3"

    $menubar.view.menu.bgimage.clear add command -label "All" -command "ac3d clear_background_image -1"


#    $menubar.view.menu add separator
#    $menubar.view.menu add command -label "3D view to selection" -command "ac3d set_view_3d_selection"
#    $menubar.view.menu add command -label "3D view to cursor" -command "ac3d set_view_3d_cursor"
 #   $menubar.view.menu add command -label "3D view to origin" -command "ac3d set_view_3d_origin"
#    $menubar.view.menu add separator


    $menubar.view.menu add cascade -label "Realtime Mirror" -menu $menubar.view.menu.mirror -underline 0

    menu $menubar.view.menu.mirror -tearoff 0
	$menubar.view.menu.mirror add radiobutton -label "Off" -variable prefs_realtime_mirror -value 0 -command {set prefs_realtime_mirror 0 ; ac3d redraw_all} -underline 0
	$menubar.view.menu.mirror add radiobutton -label "X" -variable prefs_realtime_mirror -value 1 -command { set prefs_realtime_mirror 1 ;ac3d redraw_all} -underline 0
	$menubar.view.menu.mirror add radiobutton -label "Y" -variable prefs_realtime_mirror -value 2 -command {set prefs_realtime_mirror 2 ;ac3d redraw_all} -underline 0
	$menubar.view.menu.mirror add radiobutton -label "Z" -variable prefs_realtime_mirror -value 3 -command {set prefs_realtime_mirror 3 ;ac3d redraw_all} -underline 0


    $menubar.view.menu add separator

    $menubar.view.menu add checkbutton -label "Show View Controls" -variable prefs_show_view_controls -command reconfigure_view_controls -underline 0
    $menubar.view.menu add command -label "Configure Views..." -command "menu_configure_views"  -underline 0
    $menubar.view.menu add command -label "New View..." -command "make_additional_view"  -underline 0
	
    $menubar.view.menu add separator

    $menubar.view.menu add command -label "Reset All" -command "set prefs_realtime_mirror 0; ac3d reset_views; "  -underline 0



    add_menu_balloons $menubar.view.menu { \
        "set the views so that the selection fills the windows" \
		"set the views so that the whole model can be seen" \
        "centre the views around the centre of the selection" \
        "" \
		"mirror the model across the selected axis" \
		"" \
		"Switch display of the control bar displayed at the top of each view window" \
		"Configure the layout of the view windows" \
		"create a new view window" \

		"" \
        "reset the view centering, zoom levels and mirroring" }
        


# Object menu


    menubutton $menubar.object -text "Object" -menu $menubar.object.menu -underline 0

    menu $menubar.object.menu -tearoff 0
	set UI(menu_object) $menubar.object.menu    

	$menubar.object.menu add cascade -label "Texture" -menu $menubar.object.menu.texture -underline 0
	menu $menubar.object.menu.texture -tearoff 0
	$menubar.object.menu.texture add command -label "Set no texture" -command "ac3d set_no_texture"
	$menubar.object.menu.texture add command -label "Set texture repeat/offset..." -command "menu_edit_texture_repeats"
	$menubar.object.menu.texture add command -label "Reset texture repeat/offset" -command "ac3d set_texture_repeats 1 1 ; ac3d set_texture_offsets 0 0; ac3d redraw_all"
	$menubar.object.menu.texture add command -label "Load texture..." -command "ac3d file_select_texture"
	$menubar.object.menu add separator

	$menubar.object.menu add command -label "Revolve..." -command "menu_revolve" -underline 0
    $menubar.object.menu add cascade -label "Mirror" -menu $menubar.object.menu.mirror
    menu $menubar.object.menu.mirror -tearoff 0
    $menubar.object.menu.mirror add command -label "+X" -command "ac3d object_mirror 0"
    $menubar.object.menu.mirror add command -label "+Y" -command "ac3d object_mirror 1"
	$menubar.object.menu.mirror add command -label "+Z" -command "ac3d object_mirror 2"
	$menubar.object.menu.mirror add command -label " -X" -command "ac3d object_mirror 3"
	$menubar.object.menu.mirror add command -label " -Y" -command "ac3d object_mirror 4"
	$menubar.object.menu.mirror add command -label " -Z" -command "ac3d object_mirror 5"
	$menubar.object.menu.mirror add command -label "X axis" -command "ac3d object_mirror 6"
	$menubar.object.menu.mirror add command -label "Y axis" -command "ac3d object_mirror 7"
	$menubar.object.menu.mirror add command -label "Z axis" -command "ac3d object_mirror 8"

    $menubar.object.menu add cascade -label "Boolean" -menu $menubar.object.menu.boolean
    menu $menubar.object.menu.boolean -tearoff 0
    $menubar.object.menu.boolean add command -label "Subtract" -command "ac3d boolean subtract"
    $menubar.object.menu.boolean add command -label "Intersect" -command "ac3d boolean intersect"
    $menubar.object.menu.boolean add command -label "Union" -command "ac3d boolean union"
    $menubar.object.menu.boolean add command -label "Cut Away" -command "ac3d boolean cut"
    $menubar.object.menu.boolean add separator
    $menubar.object.menu.boolean add command -label "Knife" -command "ac3d boolean knife"
    $menubar.object.menu.boolean add command -label "Knife and Cut Away" -command "ac3d boolean knifecut"

   $menubar.object.menu add separator

    $menubar.object.menu add command -label "Optimize Vertices..." -command "ac3d optimize" -underline 9 -accelerator [accel Ctrl+Shift+V]
    $menubar.object.menu add command -label "Optimize Surfaces..." -command "ac3d optimize_surfaces" -underline 9 
	$menubar.object.menu add command -label "Reduce..." -command "menu_reduce"
	$menubar.object.menu add separator



    $menubar.object.menu add command -label "Subdivide +" -command "ac3d adjust_subdivision_level 1" -underline 1
    $menubar.object.menu add command -label "Subdivide -" -command "ac3d adjust_subdivision_level -1" -underline 2
    $menubar.object.menu add command -label "Commit Subdivision" -command "ac3d commit_subdivisions" -underline 0
 #   $menubar.object.menu add command -label "Clear subdivision" -command "ac3d adjust_subdivision_level -999" -underline 2 // not undoable
     
    $menubar.object.menu add separator

    $menubar.object.menu add command -label "Re-centre" -command "ac3d object_recentre ; ac3d redraw_orth" -underline 3
    $menubar.object.menu add command -label "Minimum-centre" -command "ac3d object_mincentre ; ac3d redraw_orth" -underline 0


    $menubar.object.menu add command -label "Fragment" -command "ac3d object_fragment ; ac3d redraw_all" -underline 0
    $menubar.object.menu add command -label "Merge" -command "ac3d object_merge ; ac3d redraw_all" -underline 1 -accelerator [accel Ctrl+Shift+M]
    $menubar.object.menu add command -label "Explode..." -command "menu_object_explode" -underline 0

    $menubar.object.menu add separator
    $menubar.object.menu add command -label "Extrude Along Path" -command "ac3d extrude_along_path" -underline 1

	$menubar.object.menu add command -label "Fill Holes" -command "ac3d fill_holes"


	$menubar.object.menu add command -label "Thicken..." -command "menu_thicken"

#	$menubar.object.menu add command -label "LSCM unwrap" -command "ac3d object_lscm"
	

#    $menubar.object.menu add command -label "Define extrude path" -command "ac3d define_extrude_path" -underline 15


    add_menu_balloons $menubar.object.menu { \
		"handle object textures" \
		"" \
		"create a volume of revolution" \
		"add a mirror image of the geometry" \
		"Boolean operations" \
		"" \
        "remove duplicate vertices" \
        "remove duplicate surface and polygons with 1 or 2 vertices" \
		"reduce surfaces by removing least important vertices" \
		"" \
		"increase surface subdivision level" \
		"decrease surface subdivision level" \
		"subdivide the main object geometry to the subdivision level" \
		"" \
        "recalculate the centre of each object" \
        "calculate the minimum xyz coor and use this as the centre" \
		"put each surface into an individual object" \
        "put all selected surfaces into a single object" \
        "fragment and move each new surface in the direction it faces" 
		"" \
        "extrude defined path (select profile then shift-select path object)" \
		"create surfaces where there are holes in the geometry"  }
        

# Surface menu

    menubutton $menubar.surface -text "Surface" -menu $menubar.surface.menu -underline 0
    menu $menubar.surface.menu -tearoff 0
	set UI(menu_surface) $menubar.surface.menu    

    $menubar.surface.menu add command -label "Flip Normal" -command "ac3d surface_flip_normals" -underline 0 -accelerator [accel Ctrl+Shift+N]
	$menubar.surface.menu add command -label "Unify Normals" -command "ac3d surface_orient_adjacent" 
    $menubar.surface.menu add command -label "Change Vertex Order" -command "ac3d surface_change_vertex_order" -accelerator [accel Ctrl+Shift+O]
	#-underline 14 -accelerator [accel Ctrl+Alt+O
    $menubar.surface.menu add separator
    $menubar.surface.menu add command -label "Flip Triangle Edge" -command "ac3d flip_edge" -underline 0 

#    $menubar.surface.menu add command -label "Remove triangle edge" -command "ac3d quad_from_triangle_pair" -underline 0 
    $menubar.surface.menu add separator

    $menubar.surface.menu add command -label "Divide" -command "ac3d surface_subdivide" -underline 0 -accelerator [accel Ctrl+Shift+D]
    $menubar.surface.menu add command -label "Combine" -command "ac3d combine_surfaces" -underline 0 -accelerator [accel c]
    $menubar.surface.menu add command -label "Flatten" -command "ac3d flatten_surfaces"

    $menubar.surface.menu add command -label "Spike..." -command "menu_spike" -underline 3
    $menubar.surface.menu add command -label "Indent..." -command menu_indent -underline 0 -accelerator [accel i]
    $menubar.surface.menu add command -label "Bevel..." -command menu_bevel -underline 0 -accelerator [accel b]
    $menubar.surface.menu add command -label "Make Hole" -command "ac3d surface_make_hole" -underline 5 -accelerator [accel Ctrl+Shift+H]
    $menubar.surface.menu add command -label "Triangulate" -command "ac3d surface_triangulate"  -underline 0 -accelerator [accel Ctrl+Shift+T]
    $menubar.surface.menu add command -label "Spline" -command "ac3d surface_spline" -underline 1
    $menubar.surface.menu add separator

    $menubar.surface.menu add command -label "Cut Away Object" -command "ac3d surface_create_object"  -underline 9 -accelerator [accel Ctrl+Shift+X]
    $menubar.surface.menu add command -label "Remove Surface Only" -command "ac3d removesurface" -underline 0 
#    $menubar.surface.menu add separator

 #   $menubar.surface.menu add cascade -label "Remap texture coords" -menu $menubar.surface.menu.remaptexture
    menu $menubar.surface.menu.remaptexture -tearoff 0
#define PROJFRONT (0)
#define PROJLEFT (1)
#define PROJTOP (2)
#define PROJBACK (3)
#define PROJRIGHT (4)
#define PROJBOTTOM (5)
#define PROJ3D (6)
    $menubar.surface.menu.remaptexture add command -label "XY (Front)" -command "ac3d remap_textures 0" -underline 4
    $menubar.surface.menu.remaptexture add command -label "ZY (Side)" -command "ac3d remap_textures 1" -underline 4
    $menubar.surface.menu.remaptexture add command -label "XZ (Plan)" -command "ac3d remap_textures 2" -underline 4
    $menubar.surface.menu.remaptexture add command -label "Spherical" -command "ac3d remap_textures 6" -underline 1

    $menubar.surface.menu add separator
    $menubar.surface.menu add command -label "Calculate Surface Area..." -command "ac3d calc_surface_area"  -underline 18

# for testing, probably not needed by the public?	$menubar.surface.menu add command -label "Random Flip" -command "ac3d surface_randomize_normals" 


    add_menu_balloons $menubar.surface.menu { \
        "reverse the order of the vertices so that the normal is flipped" \
		"change surface directions so that they match the selected (single) surface" \
        "put the first vertex to the end of the surface" \
		"" \
		"flip the edge of two adjacent triangles" \
        "" \
		"split quads into 4 smaller surfaces, triangles into 3" \
		"combine two or more surfaces together to make one surfaces" \
		"move vertices so they lie on a plane" \
        "create a spike on each quad/triangle" \
		"create new surfaces aroundthe inside of each selected surface (flat bevel)"
        "create a beveled surface by creating more surfaces" \
		"make a hole in each selected surface" \
        "divide polygons into triangles" \
		"interpolate points between the current vertices" \
        "" \
		"take selected surfaces and put them into a new object" \
		"remove selected surfaces, leave the vertices"\
        "" \
		"calculate the total surface area of all selected polygons"\
		}




# Vertex menu
    menubutton $menubar.vertex -text "Vertex" -menu $menubar.vertex.menu -underline 5
    menu $menubar.vertex.menu -tearoff 0
	set UI(menu_vertex) $menubar.vertex.menu

   $menubar.vertex.menu add command -label "Snap Together" -command "ac3d snaptogether"  -underline 0 -accelerator [accel Ctrl+T]
    $menubar.vertex.menu add command -label "Snap Together by Distance..." -command "menu_snap_together_distance"
    $menubar.vertex.menu add command -label "Snap to Grid" -command "ac3d snaptogrid" -underline 8
    $menubar.vertex.menu add command -label "Snap Objects by Vertices" -command "ac3d object_snap_together_by_vertices" -underline 16
#    $menubar.vertex.menu add command -label "Snap Object Vertex Pairs" -command "ac3d snap_object_vertex_pairs" -underline 19
   $menubar.vertex.menu add command -label "Snap To First Vertex" -command "ac3d snaptofirst"  -underline 8 -accelerator [accel Ctrl+U]

   $menubar.vertex.menu add separator

	$menubar.vertex.menu add command -label "Smooth Shape" -command "ac3d smooth_vertices"
	    $menubar.vertex.menu add command -label "Spherize" -command "ac3d spherize" -underline 8
    $menubar.vertex.menu add separator

    $menubar.vertex.menu add cascade -label "Align to Axis" -menu $menubar.vertex.menu.alignaxis
    menu $menubar.vertex.menu.alignaxis -tearoff 0
    $menubar.vertex.menu.alignaxis add command -label "X" -command "ac3d align_vertices_to_axis 0" -underline 0
    $menubar.vertex.menu.alignaxis add command -label "Y" -command "ac3d align_vertices_to_axis 1" -underline 0
    $menubar.vertex.menu.alignaxis add command -label "Z" -command "ac3d align_vertices_to_axis 2" -underline 0

    $menubar.vertex.menu add separator
    $menubar.vertex.menu add command -label "Weld" -command "ac3d weld_vertices" -underline 0 
    $menubar.vertex.menu add command -label "Unweld" -command "ac3d unshare_vertices" -underline 0 
    $menubar.vertex.menu add command -label "Insert Vertex" -command "ac3d insert_vertex" -underline 0 -accelerator [accel Ctrl+Shift+I]

    $menubar.vertex.menu add command -label "Divide Triangle Edge" -command "ac3d divide_edge" -underline 0 
    $menubar.vertex.menu add command -label "Extrude Edges" -command "ac3d extrude_edges" -underline 0 -accelerator [accel Ctrl+e]

	$menubar.vertex.menu add command -label "Slice Surface" -command "ac3d surface_slice" -underline 0 -accelerator [accel Ctrl+Shift+L]

	    $menubar.vertex.menu add separator

    $menubar.vertex.menu add command -label "Create Convex Surface/Object" -command "ac3d convexhull" -underline 0
    $menubar.vertex.menu add command -label "Create Ordered Surface" -command "ac3d createsurface" -underline 7 -accelerator [accel Ctrl+Shift+S]
	$menubar.vertex.menu add command -label "Create Quad" -command "ac3d create_quad" -underline 7 -accelerator [accel Ctrl+r]

    $menubar.vertex.menu add cascade -label "Create 2D Mesh" -menu $menubar.vertex.menu.createmesh

    menu $menubar.vertex.menu.createmesh -tearoff 0
    $menubar.vertex.menu.createmesh add command -label "XY (Front)" -command "ac3d delaunay 0" -underline 4
    $menubar.vertex.menu.createmesh add command -label "ZY (Side)" -command "ac3d delaunay 1" -underline 4
    $menubar.vertex.menu.createmesh add command -label "XZ (Plan)" -command "ac3d delaunay 2" -underline 4


#    $menubar.vertex.menu add cascade -label "LSCM Seams" -menu $menubar.vertex.menu.setseam
#    menu $menubar.vertex.menu.setseam -tearoff 0
#    $menubar.vertex.menu.setseam add command -label "Set seam" -command "ac3d vertices_set_uv_seam 1" -underline 0
#    $menubar.vertex.menu.setseam add command -label "Unset seam" -command "ac3d vertices_set_uv_seam 0" -underline 0


    add_menu_balloons $menubar.vertex.menu { \
        "move selected vertices to the same point" \
		"move vertices together that are within a specified distance" \
        "move selected vertices to the nearest grid point" \
        "move one object to another so that the two selected vertices match position" \
		"move vertices to the position of the first selected" \
		"" \
		"move the selected vertices so the overall shape is smoothed" \
		"move vertices to a sphere based around the centre of selection" \
		"" \
		"move all vertices to zero on the specified axis" \
		"" \
		"remove duplicate vertices that are at the same position" \
		"add new vertices so that each surface references a unique vertex" \
        "insert a new vertex between each pair of selected vertices" \
		"insert a new vertex and split the surface at that point" \
		"from two vertices, extrude an edge to create a new surface" \
		"split a surface into two, across two vertices" \
        "" \
		"make a new object with surfaces spanning selected vertices" \
		"create a single surface using vertices in order selected" \
		"from three vertices, create a new vertex and a quad surface" \
		"create a 2D (triangle) mesh from the selected vertices" }





# 3D menu

    menubutton $menubar.3d -text "3D" -menu $menubar.3d.menu -underline 0
    menu $menubar.3d.menu -tearoff 0
	set UI(menu_3d) $menubar.3d.menu

$menubar.3d.menu add checkbutton -label "Wireframe" -variable prefs_view3dmode -command "ac3d redraw_3d" -underline 0 -accelerator [accel w]
    $menubar.3d.menu add checkbutton -label "Texture" -variable prefs_view3dtextures -command "ac3d redraw_3d" -underline 0 -accelerator [accel t]
    $menubar.3d.menu add checkbutton -label "Vertices" -variable prefs_show_vertices_3d -command "ac3d redraw_3d" -underline 0
    $menubar.3d.menu add checkbutton -label "Surfaces" -variable prefs_show_surfaces_3d -command "ac3d redraw_3d" -underline 0
    $menubar.3d.menu add checkbutton -label "Headlight" -variable prefs_headlight -command "ac3d redraw_3d" -underline 4
    $menubar.3d.menu add checkbutton -label "Normals" -variable prefs_show_3d_normals -command "ac3d redraw_3d" -underline 0 -accelerator [accel n]
    $menubar.3d.menu add checkbutton -label "Grid" -variable prefs_grid3d_show -command "ac3d redraw_3d" -underline 0
    $menubar.3d.menu add checkbutton -label "Subdivisions" -variable prefs_preview_subdivisions_3d -command "ac3d redraw_3d" -underline 3 -accelerator [accel d]
    $menubar.3d.menu add separator

    $menubar.3d.menu add checkbutton -label "Interactive Wireframe" -variable prefs_wireframe_move -underline 0 
    $menubar.3d.menu add separator

    $menubar.3d.menu add checkbutton -label "Show Axis" -variable prefs_show_axis -command "ac3d redraw_3d" -underline 0
    $menubar.3d.menu add checkbutton -label "Show Hidden Objects" -variable prefs_show_hidden_3d -command "ac3d redraw_3d" -underline 0 
    $menubar.3d.menu add checkbutton -label "Show Locked Objects" -variable prefs_show_locked_3d -command "ac3d redraw_3d" -underline 0 

    $menubar.3d.menu add checkbutton -label "Show Subdivision Originals" -variable prefs_show_proxy_subdivisions_3d -command "ac3d redraw_3d" -underline 0 

#    $menubar.3d.menu add separator

#    $menubar.3d.menu add radiobutton -label "Spin" -variable person_walk_vehicle -value 0 -command {ac3d set_spin_viewer ; ac3d redraw_3d} -underline 0 -accelerator [accel 1]
#    $menubar.3d.menu add radiobutton -label "Walk" -variable person_walk_vehicle -value 1 -command {ac3d set_walk_viewer ; ac3d redraw_3d} -underline 3 -accelerator [accel 2]
#    $menubar.3d.menu add separator
#    $menubar.3d.menu add command -label "FOV..." -command "dialog_FOV" -underline 2

    add_menu_balloons $menubar.3d.menu { \
        "view filled or wireframe polygons?" \
        "view textures?" \
		"view vertices (in vertex mode)"\
		"outline surfaces (when not in vertex mode)"\
        "switch on the viewing light?" \
        "show surface normals?" \
		"view the 3D grid?" \
		"preview any subdivided objects?" \
		"" \
        "display model in wireframe when dragging the mouse?" \
        "" \
        "view the axis guide?" \
        "show hidden objects?" \
        "show locked objects?" 
		"show the original surfaces and vertices from subdivided objects" 
#        "" 
 #       "select spin view mode - mouse and cursor keys spin the model" \
  #      "select walk view mode - cursor keys (with alt/ctrl) move view point" \
   #     "" \
    #    "adjust the field-of-view"
	}



# Orth menu

    menubutton $menubar.orth -text "2D" -menu $menubar.orth.menu -underline 0
    menu $menubar.orth.menu -tearoff 0
	set UI(menu_orth) $menubar.orth.menu

#adding accelerators to menu checkbuttons or radio buttons causes problems on the MAC

    $menubar.orth.menu add checkbutton -label "Wireframe" -variable prefs_filled_orth -onvalue 0 -offvalue 1 -command "ac3d redraw_orth" -underline 0 -accelerator [accel w]
#not mac! -accelerator [accel w
    $menubar.orth.menu add checkbutton -label "Texture" -variable prefs_orth_textures -command "ac3d redraw_orth" -underline 0 -accelerator [accel t]
#not mac  -accelerator [accel t
    $menubar.orth.menu add checkbutton -label "Vertices" -variable prefs_show_vertices -command "ac3d redraw_orth" -underline 0 
    $menubar.orth.menu add checkbutton -label "Surfaces" -variable prefs_show_surfaces -command "ac3d redraw_orth" -underline 0
    $menubar.orth.menu add checkbutton -label "Headlight" -variable prefs_orth_headlight -command "ac3d redraw_orth" -underline 4
    $menubar.orth.menu add checkbutton -label "Normals" -variable prefs_show_normals_orth -command "ac3d redraw_orth" -underline 0 -accelerator [accel n]
    $menubar.orth.menu add checkbutton -label "Grid" -variable prefs_show_drawgrid -command "ac3d redraw_orth" -underline 0
    $menubar.orth.menu add checkbutton -label "Subdivisions" -variable prefs_preview_subdivisions_orth -command "ac3d redraw_orth" -underline 3 -accelerator [accel d]

    $menubar.orth.menu add separator
    $menubar.orth.menu add checkbutton -label "Interactive Wireframe" -variable prefs_move_wireframe_orth -underline 0 

    $menubar.orth.menu add separator
	$menubar.orth.menu add checkbutton -label "Show Axis Guides" -variable prefs_show_orth_axis -command "ac3d redraw_orth" -underline 0

    $menubar.orth.menu add checkbutton -label "Col Wireframe" -variable prefs_use_rgb_for_orth -command "ac3d redraw_orth" -underline 0 
    $menubar.orth.menu add separator
    $menubar.orth.menu add checkbutton -label "Object Centres" -variable prefs_show_objectcentres -command "ac3d redraw_orth" -underline 0 
#    $menubar.orth.menu add checkbutton -label "Selected Vertices" -variable prefs_show_selected_vertices -command "ac3d redraw_orth" -underline 0 
    $menubar.orth.menu add checkbutton -label "Show Subdivision Originals" -variable prefs_show_proxy_subdivisions_orth -command "ac3d redraw_orth" -underline 0 


    add_menu_balloons $menubar.orth.menu { \
        "view the 2D model as wireframe or filled?" \
        "view textures on filled polygons?" \
		"show selectable vertices?" \
		"show selectable surface?" \
        "use viewing light?" \
		"show surface normals?" \
        "show the grid?" \
		"preview any subdivided objects?" \
        "" \
        "switch to wireframe when dragging/scaling view?" \
		"" \
		"Display the axis guides?" \
        "use actual surface cols in wireframe?" \
        "" \
        "show object centres?" \
        "show original objects for subdivisions?"\
        }






# tools menu
    menubutton $menubar.tools -text "Tools" -menu $menubar.tools.menu -underline 0
    menu $menubar.tools.menu -tearoff 0
	set UI(menu_tools) $menubar.tools.menu

    if { $ac_platform == "SGI" } {
        $menubar.tools.menu add command -label "Go Stereo" -command "tools_stereo" -underline 4
        }

    $menubar.tools.menu add command -label "Model Info..." -command "menu_info" -underline 6 -accelerator [accel F6]
    $menubar.tools.menu add command -label "Render..." -command "menu_render" -underline 0 -accelerator [accel F7]
    $menubar.tools.menu add command -label "Hierarchy View..." -command "menu_hier" -underline 0 -accelerator [accel F8]
    $menubar.tools.menu add command -label "Object Property Editor..." -command "edit_dive_data" -underline 7 -accelerator [accel F9]
    $menubar.tools.menu add command -label "Texture Coordinate Editor..." -command "menu_uveditor" -underline 0 -accelerator [accel F10]
    $menubar.tools.menu add command -label "Replicator..." -command "menu_replicator" -underline 0 -accelerator [accel F11]
    $menubar.tools.menu add command -label "Create 2D/3D Text..." -command "ttfont_dialog" -underline 0 -accelerator [accel F12]

    $menubar.tools.menu add command -label "Align Objects..." -command menu_align_objects
    $menubar.tools.menu add command -label "Position 3D Cursor..." -command "menu_position_cursor" -underline 4

    $menubar.tools.menu add separator
#    $menubar.tools.menu add command -label "Add simple text..." -command "dialog_addtext" -underline 4


#    $menubar.tools.menu add command -label "TEST" -command "ac3d test"


    add_menu_balloons $menubar.tools.menu { \
        "display information about the current model" \
        "render the current model in an external renderer" \
        "display the model tree" \
        "edit object specific data" \
		"start the texture coordinate editor" \
        "replicate geometry" \
		"create text from a truetype font file" \
		"align objects" \
		"position the 3d cursor" \
		"" \
        
	}

	

# HELP menu
    menubutton $menubar.help -text "Help" -menu $menubar.help.menu -underline 0    

    menu $menubar.help.menu -tearoff 0
	$menubar.help.menu add command -label "Manual..." -underline 0 -command "start_web_browser_file manual/index.htm"
    $menubar.help.menu add separator

    $menubar.help.menu add command -label "About AC3D..." -command "ac3d menu_about" -underline 0
    $menubar.help.menu add command -label "About Importers..." -command "menu_about_importers" -underline 1
    $menubar.help.menu add command -label "About Exporters..." -command "menu_about_exporters" -underline 1
    $menubar.help.menu add command -label "About Plugins..." -command "menu_about_plugins" -underline 6
    $menubar.help.menu add command -label "Online Homepage..." -underline 7 -command "ac3d start_web_browser http://www.inivis.com"
	$menubar.help.menu add command -label "Online Forum..." -underline 7 -command "ac3d start_web_browser http://www.inivis.com/forum"
    $menubar.help.menu add separator
    $menubar.help.menu add command -label "Credits..." -command "ac3d menu_credits" -underline 0
	$menubar.help.menu add separator

#    $menubar.help.menu add command -label "Check for updates..." -underline 5 -command menu_check_for_updates
#    $menubar.help.menu add separator

	if { [ac3d get_app_mode] != 2 } {
		$menubar.help.menu add command -label "Enter License Key..." -command menu_register -underline 0
	} else {
		$menubar.help.menu add command -label "Upgrade License..." -command menu_register -underline 0
	}

    add_menu_balloons $menubar.help.menu { 
		"View the AC3D manual" \
		"" \
		"Information about AC3D" \
		"info on file importers" \
		"info on file exporters" \
		"plugin information" \
		"start up a web browser with the AC3D home page" \
		"start web browser and goto the AC3D community forum" \
		"" \
		"Credits" \
		"" \
		"enter your registration key to fully enable/upgrade AC3D" \
		"" \
		}




# MAC APPLE MENU
	if { $ac_platform == "Mac" } {
		menu $menubar.apple -tearoff 0
		set UI(menu_apple) $menubar.apple.menu
		$menubar.apple add command -label "About AC3D..." -command "ac3d menu_about" -underline 0
	}



# pack the menus into the menubar

    if { $tcl_version >= 8 } {
	    set m $menubar
#		menu $m -tearoff 0 -type toplevel

		if { $ac_platform == "Mac" } {
			$m add cascade -menu $menubar.apple -label "AC3D" -underline 0
		}

		$m add cascade -menu $menubar.file -label "File" -underline 0
		$m add cascade -menu $menubar.edit.menu -label "Edit" -underline 0
		$m add cascade -menu $menubar.view.menu -label "Views" -underline 0
		$m add cascade -menu $menubar.object.menu -label "Object" -underline 0
		$m add cascade -menu $menubar.surface.menu -label "Surface" -underline 0
		$m add cascade -menu $menubar.vertex.menu -label "Vertex" -underline 5
		$m add cascade -menu $menubar.orth.menu -label "2D" -underline 0
		$m add cascade -menu $menubar.3d.menu -label "3D" -underline 0
		$m add cascade -menu $menubar.tools.menu -label "Tools" -underline 0
		$m add cascade -menu $menubar.help.menu -label "Help " -underline 0
# 18th Dec 2007 - added a space after the Help label to prevent the search menu appearing

		. configure -menu $menubar

#        pack $menubar.file $menubar.edit  $menubar.view $menubar.object $menubar.surface $menubar.vertex $menubar.orth $menubar.3d $menubar.tools -side left
#        pack $menubar.help -side right


    } else {    
        pack $menubar.file $menubar.edit $menubar.view $menubar.object $menubar.surface $menubar.vertex $menubar.orth $menubar.3d $menubar.tools -side left
        pack $menubar.help -side right
    }


}
