# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.

set last_save_settings 0



proc prepare_to_save_settings { } {
# this is called from AC3D save_settings and allows any final values to be set in the prefs_ variables before AC3D 
# saves the settings.

	global prefs_ui_setting_all
	global UI
	global prefs_ui_leftpane_sash_percent
	global prefs_ui_gadget_layout
	global prefs_mainwin_maxed

#	if { $prefs_ui_setting_all == "" } {
#	 puts "!!!!!!!!!!!!!!!!!!!!!!!!!settings gone!!!!!!!!!!!!!!!!!! prefs_ui_setting_all=$prefs_ui_setting_all" 
#	 tk_messageBox -title "AC3D message" -message "SETTINGS GONE!" -type ok -icon info -parent .
#	 }


	set leftpaneheight [winfo height $UI(leftpane)]

	set sashat [ $UI(leftpane) sashpos 0 ]

	set prefs_ui_leftpane_sash_percent [ expr ((double($sashat)/double($leftpaneheight))*100.0) ]


	set prefs_ui_gadget_layout [ get_gadget_layout ]

	set mainwinstate  [ wm state . ]
	if { $mainwinstate == "zoomed" } {
		set prefs_mainwin_maxed 1
	} else {
		set prefs_mainwin_maxed 0
	}
}





proc prefs_changed { } {
global prefs_recalc_normals
global prefs_save_settings_on_exit
global last_save_settings

	 if { ! $prefs_recalc_normals } {
		 if { ![winfo exists .recalc_normals] } {
			 cbutton .recalc_normals "Recalc normals" "ac3d recalc_normals_all; ac3d redraw_3d"
			 add_balloon .recalc_normals "Force recalculation of lighting normals"
			 pack .recalc_normals -in .cp -side top
		 }
	 } else {
		 catch {destroy .recalc_normals }
	 }

	 set_socket_commands

	if { ($last_save_settings != $prefs_save_settings_on_exit) && (!$prefs_save_settings_on_exit) } {
		set answer [tk_messageBox -message "'Save settings on Exit' is now off - You must save settings now if you want this to be remembered.\n\n(to save settings in the future, you can use the save button which will now be at the bottom of the settings dialog)\n\nSave the current settings now?" -title "Save settings?" -type yesno -icon question]
		case $answer {
			yes {
				 ac3d save_settings
				 }
			no {}
		}
	}

	ac3d redraw_all

}



proc build_uisettings_panel { parent } {

	set par [ ac_create_pair_frame $parent  ]

	global uisetting UI
	global prefs_ui_setting_all
	global prefs_ui currentuiname uisetting

	# pull the array of saved setings from the single pref
	array set uisetting $prefs_ui_setting_all 

		proc refresh_ui_setting_list {} {
			global uisetting UI prefs_ui_setting_all
			
			$UI(setting_list) delete 0 end

			set sorted [lsort -stride 2 -nocase [array get uisetting]]

			foreach { key value} $sorted {
				$UI(setting_list)  insert end $key 
			}
			set prefs_ui_setting_all [array get uisetting]
		}

	set lscroll [ ac_scrollbar $par.scr -orient vertical ]

	set listw [ac_listbox $par.list -height 5 -width 30 -borderwidth 2 ]
	set UI(setting_list) $listw

	$lscroll configure -command [list $listw yview]
	$listw configure -yscrollcommand [list $lscroll set]

	refresh_ui_setting_list
	grid $lscroll -row 0 -column 0 -sticky ns -padx {0 2}
	grid $listw -row 0 -column 1 -sticky we




		
		proc save_current_settings {} {
			global prefs_ui currentuiname uisetting

			if { $currentuiname == "" } {
				puts "Please supply a name for this UI setting config"
				return
			}

			array set copy [array get prefs_ui]

			set arrayflat [array get prefs_ui]
			#parray copy
			set uisetting($currentuiname) $arrayflat
			refresh_ui_setting_list
		}

	set currentuiname ""
	set name [ttk::entry $par.name -textvariable currentuiname ]
	grid $name -row 1 -column 1 -sticky we

		proc set_new_ui { name } {
			global uisetting
			global prefs_ui

			#parray prefs_ui

			array set prefs_ui $uisetting($name)
			#parray prefs_ui
			configure_ac3d_theme
		}

		proc apply_share_settings { arrayval } {
			global uisetting
			global prefs_ui
			
			if {$arrayval == ""} { return}
			set backup [array get prefs_ui ]
			
			if { [catch {array set prefs_ui $arrayval} ] } {
				display_message "failed to apply UI settings"
				return
			}

			if { [ catch { configure_ac3d_theme } ] } {
				display_message "error occured when configuring theme"
				array set prefs_ui $backup
				configure_ac3d_theme
			}

		}

# problm with the share thing - any old text can be put in and errors only happen AFTER the whole thing is processed


	set shareouter [ FoldFrame:create $par.sharefold "Share" 0 0]
	set sharecontainer [FoldFrame:get_container $shareouter]
	set shareapply [ ac_button $sharecontainer.but -text "Apply" ]
	add_balloon $shareapply "Apply these settings"

	set lab [ttk::entry $sharecontainer.lab -textvariable currentui ]
	$shareapply configure -command { apply_share_settings $currentui }

	pack $shareapply -side right -expand 0 
	pack $lab -side left -fill x -expand 1
	grid $shareouter -row 2 -column 1 -columnspan 2 -sticky we


	set f [ac_frame $par.bframe ]
	grid $f -row 0 -column 2 -sticky nwe

	ac_button $f.applysel -text "Apply" -command { set c [$UI(setting_list) curselection] ; if { $c != "" } { set u [$UI(setting_list) get $c ]; puts $u; set_new_ui $u } }
	add_balloon $f.applysel "use the currently selected UI settings"

	grid $f.applysel -row 0 -column 0 -sticky nwe

	ac_button $f.rem -text "Remove" -command { 
		set c [$UI(setting_list) curselection]
		if { $c != "" } { 
			set u [$UI(setting_list) get $c ]
			puts $u
			$UI(setting_list) del $c
			unset uisetting($u)
		}

	}
	add_balloon $f.rem "delete the selected settings config"

	grid $f.rem -row 1 -column 0 -sticky nwe

	bind $listw <Button-1> { set currentuiname [%W get [%W nearest %y]] ; set currentui [lsort -stride 2 -nocase $uisetting($currentuiname) ]}
	set selcom { set currentuiname [%W get [%W nearest %y]] ; set currentui $uisetting($currentuiname) ; \
		set_new_ui $currentuiname }
	bind $listw <Double-1> $selcom
	bind $listw <Return> $selcom
		



		proc show_all_settings { parent } {
			global uisetting
			set uiall [lsort -stride 2 -nocase [array get uisetting]]
			set t [ text $parent.t -width 60 -height 10]
			pack $t -fill both -expand 1
			$t insert 0.0 $uiall
		}



	ac_button $par.save -text "Save" -command save_current_settings
	add_balloon $par.save "Save the current setting with under the adjacent name.\n(Hold control key when presing this button to display all settings in a text box)"
	grid $par.save -row 1 -column 2 -sticky we

	bind $par.save <Control-Button-1> { 
			set uiall [array get uisetting ]
			ac_toplevel_with_close .showallsettings "All Settings" show_all_settings
			}

	return $par

}













proc show_settings {} {

global prefs_save_settings_on_exit UI
global last_save_settings tcl_platform ac_platform

	set last_save_settings $prefs_save_settings_on_exit

	new_toplevel .panel "Settings"
	set settings_frame [ac_frame .panel.sf]
	pack $settings_frame -fill both -expand 1

	set n $settings_frame.notebook

if { 1 == 0} {
	Notebook:create $n -pages {General "3D View" Appearance Files Advanced} -pad 20 ]
	pack .panel.notebook -fill both -expand 1
	set wg [Notebook:frame $n General]
	set w3 [Notebook:frame $n "3D View"]
	set wap [Notebook:frame $n Graphics]
	set wad [Notebook:frame $n Advanced]
	set	wf [Notebook:frame $n Files]
}

set pad 5
set UI(prefs_notebook) $n
ttk::notebook $n

	proc add_tab { n name text } {
	global pad
		set tab $n.$name
		$n add [ttk::frame $tab] -text $text -padding 5
		# add an additional frame which centers in the tab
		ttk::frame $tab.f
		grid columnconfigure $tab.f 0 -uniform upref$name -weight 1
		grid columnconfigure $tab.f 1 -uniform upref$name -weight 1
		pack $tab.f
		return $tab.f
	}


set wg [add_tab $n wg "General"]
set wui [add_tab $n wui "UI"]
set wap [add_tab $n wap "Graphics"]
set w3 [add_tab $n w3 "3D View"]
set wf [add_tab $n wf "Files"]
set wm [add_tab $n wm "Materials"]
set wad [add_tab $n wad "Advanced"]


ttk::notebook::enableTraversal $n

# record and set the current tab
bind $UI(prefs_notebook) <<NotebookTabChanged>> {set UI(current_prefs_tab) [%W select] }
catch { $UI(prefs_notebook) select $UI(current_prefs_tab) }


pack $n -padx 8 -pady 3 -fill both


set w $wg

	# GENERAL
	ac_create_pair_label_entry_float $wg prefs_drawgrid "Draw grid major" "dimension for the thicker visible lines in the orthographic windows"
	ac_create_pair_label_entry_float $wg prefs_grid "Draw Grid minor (snap grid)" "dimension for the thin grid lines - also defines the snap grid\nactive when 'gridsnap' is on"
	ac_create_pair_label_entry_int $wg prefs_snap_near_pixels "Near snap pixels" "how near the pointer must be to a point before it will snap to it\n(when drawing polys/polylines/lines)"
	ac_create_pair_label_entry_int $wg prefs_hole_percent "Make hole %" "percentage of hole to make in Surface->make hole"
#	ac_create_pair_label_entry_float $wg prefs_bevel_size "Bevel size (units)" "bevel size used in Surface->Bevel" 
	ac_create_pair_label_entry_float $wg prefs_mouse_rotate_degs "Mouse rotate (degrees)" "steps of rotations when rotating selections with the mouse" 
	ac_create_pair_label_entry_float $wg prefs_move_normal_distance "Move along normal dist." "Distance to move selected surfaces when +/- keys are pressed" 
	ac_create_pair_label_bool $wg prefs_balloon_help "Balloon help" "Switch these balloons off!"
	ac_create_pair_label_bool $wg prefs_fit_view_after_load "Fit view after load" "zoom views in towards objects after loading?"
	ac_create_pair_label_bool $wg prefs_rotate_about_object_centre "Rotate about object centre?" "when using the mouse to rotate a (single) object - \nuse the mouse point or the object's centre to rotate about?"
	ac_create_pair_label_bool $wg prefs_show_startup_tips "Show tips on startup" "show the AC3D tip window when the program starts?"
	ac_create_pair_label_bool $wg prefs_shift_duplicated "Offset duplicates" "if set, duplicate offset the position of the new object/surfaces"
	ac_create_pair_label_bool $wg prefs_backup_ac_file_overwrites "Create ac backup files" "On overwriting, create backup files (name + .bak) ?" 
	ac_create_pair_label_bool $wg prefs_show_locked_objects_as_wireframe "Show locked objects as wireframe" "Show locked objects as wireframe or full render (wireframe is faster and useful for large models/scenes)"

	ac_create_pair_label_spinbox $wg prefs_info_decimal_precision "Info decimal places" "The number of decimal places displayed within the info box at top of the control panel\n(requires AC3D to be restarted)" 2 1 9
	ac_create_pair_label_spinbox $wg prefs_ui_float_precision "Field decimal places" "The number of decimal places used for the final result from in-field calculations" 2 1 9

	ac_create_pair_label_bool $wg prefs_swap_middle_right_mbs "Swap middle and right mouse buttons *" "in views, middle=pan, right=zoom; switch this on to swap (*=requires restart of AC3D)"


	# UI

		proc font_changed { f } {
			global prefs_ui

				#puts "new font $f"
				set prefs_ui(font) $f
				configure_ac3d_theme
		}


	global prefs_ui

	ac_create_pair_label_col_hash_edit $wui prefs_ui(background) "Background" "widget background" configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(foreground) "Foreground" "main text col"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(textcolor) "Text" " text/field col"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(textbackground) "Text background" " text/field background col"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(buttonbackground) "Button background" "background col of buttons"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(buttonhover) "Button hover col" "button col when mouse is above"  configure_ac3d_theme

	ac_create_pair_label_col_hash_edit $wui prefs_ui(light) "Highlight" "light col used for top left of 3D borders on buttons"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(dark) "Shade" "dark col used for bottom right of the 3D borders on buttons"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(border) "Border" "border col used for outline of buttons"  configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(trough) "Trough" "background of scrollbars and sliders" configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(selectforeground) "Selection foreground" "selection forground" configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(selectbackground) "Selection background" "selection background" configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(disabledbackground) "Disabled background" "disabled background" configure_ac3d_theme
	ac_create_pair_label_col_hash_edit $wui prefs_ui(disabledforeground) "Disabled foreground" "disabled foreground" configure_ac3d_theme

	ac_create_pair_label_fontedit $wui prefs_ui(font) "Font" "Main UI font" font_changed

#	ac_create_pair_label_col_hash_edit $wui "prefs_ui(trough)" "trough" "trough" configure_ac3d_theme
#	label_bool $wui "prefs_ui(buttonborders)" "button borders" "button borders"
#	ttk::checkbutton $wui.bdrs -text "Button borders" -variable prefs_ui(buttonborders)
#	grid $wui.bdrs

	proc reset_ui_settings { what } {
		global UI
		destroy .panel
		set_default_ui_conf $what
		configure_ac3d_theme
		show_settings

	}

	ac_create_pair_spacer $wui
	set bf [ ac_create_pair_frame $wui ]
	set b1 [ ac_button $bf.b1 -text "Default Font" -command { reset_ui_settings font } ]
	set b2 [ ac_button $bf.b2 -text "Default Cols" -command { reset_ui_settings cols } ]
	pack $b1 $b2 -side left
	
	ac_create_pair_spacer $wui

	set uis [ build_uisettings_panel $wui ]
	grid $uis 
	ac_create_pair_spacer $wui

	grid columnconfigure $wui 0 -weight 0
	grid columnconfigure $wui 1 -weight 0

	# 3D View
	ac_create_pair_label_coledit $w3 prefs_col_3dbackground "3D background" "specifies the background col of the 3d windows"
	ac_create_pair_label_coledit $w3 prefs_col_3dgrid "3D grid" "specifies the col of the 3D grid"
	ac_create_pair_label_entry_float $w3 prefs_grid3d_square "3D Grid dimension" "size (units) of grid in 3D windows"
	ac_create_pair_label_entry_float $w3 prefs_grid3d_size "3D Grid square" "size (units) of one grid square 3D windows"
	# 3d grid lw doesn't work
	ac_create_pair_label_entry_float $w3 prefs_grid_3d_line_width "3D Grid line thickness" "width of lines that make up the 3D window's grid"
	ac_create_pair_label_entry_float $w3 prefs_3d_axis_line_width "3D axis line thickness" "width of lines that make up the 3D window's axis"

	ac_create_pair_label_entry_float $w3 prefs_axis_size "3D Axis size" "size (m) of axis in 3D windows"
	ac_create_pair_label_entry_float $w3 prefs_walk_move_speed "Walkmode mouse move speed" "distance to move each step when mouse is used in the 3D window's walk-mode"
	ac_create_pair_label_entry_float $w3 prefs_walk_turn_speed "Walkmode mouse turn speed" "degree at which to turn when mouse is moved left/right when flying in 3D window"
#	ac_create_pair_label_entry_float $w3 prefs_fov "Default FOV" "field of view of the 3D camera (1-180 degs)"


	# GRAPHICS


	ac_create_pair_label_coledit $wap prefs_col_background "Orth background col" "specifies the background col of the orth windows"
	ac_create_pair_label_coledit $wap prefs_col_grid "Orth grid col" "specifies the col of the orth grids"
	ac_create_pair_label_coledit $wap prefs_col_vert "Vertex col" "Unselected vertex col"
	ac_create_pair_label_coledit $wap prefs_col_selvert "Selected col" "Selected items col (vertices, surfaces etc)"

	ac_create_pair_label_coledit $wap prefs_col_edge "Edge col" "Col of surface edges"
	ac_create_pair_label_coledit $wap prefs_col_locked "Locked object col" "Col of wireframes for locked objects"
	
	ac_create_pair_label_coledit $wap prefs_uveditor_bgcol "TCE background col" "background col of Texture Coordinate Editor"
	ac_create_pair_label_coledit $wap prefs_uveditor_edgecol "TCE edge col" "col of lines drawn in the Texture Coordinate Editor"

	ac_create_pair_label_entry_int $wap prefs_vert_size "Vertex point size (pixels)" "specifies vertex size"
	ac_create_pair_label_entry_int $wap prefs_vert_size_selected "Selected vertex point size (pixels)" "specifies selected vertex size"
	ac_create_pair_label_entry_int $wap prefs_handle_size "Handle size (pixels)" "size of handles at edges of the selection box"
	ac_create_pair_label_entry_float $wap prefs_size_show_normals "Size of display normals" "the size to draw the lines representing surface normals"


	ac_create_pair_label_entry_float $wap prefs_bb_line_width "BB line thickness" "width of the bounded box that is drawn around the current selection"
	ac_create_pair_label_entry_float $wap prefs_surface_line_width "Surface outline thickness" "line width of surface outline"
	ac_create_pair_label_entry_float $wap prefs_surface_selected_line_width "Surface outline thickness (sel)" "line width of a selected surface outline"

#	ac_create_pair_label_bool $wap prefs_show_window_labels "Display window labels?" "Show the window labels at the top of the orth windows?"
	ac_create_pair_label_bool $wap prefs_polygon_offset "Polygon Offset" "If set, polygons are moved back slightly so that surface outlines can be seen more clearly"

	ac_create_pair_label_bool $wap prefs_selected_surface_stipple "Stipple selected surfaces" "stipple a pattern over surfaces that are selected,\n ratherthan just outlining them"
	ac_create_pair_label_bool $wap prefs_smooth_surface_outlines "Smooth surface outlines" "if on, surface outlines will be drawn anti-aliased.  Good for fast graphics cards but may slow down with older cards"


	# FILE
#	ac_create_pair_label_entry $wf prefs_fontpath "Fontpath" "File path for AC3D font file used in 'Add text'"

	ac_create_pair_label_entry $wf prefs_pov_file_header "POV header" "Text output at the very top of a POV file" 
	ac_create_pair_label_bool $wf prefs_pov_use_object_data "Use object data for POV files" "Use object data in POV file output"

	ac_create_pair_label_bool $wf prefs_swap_3ds_yz "3DS swap yz" "if set, 3DS importer and exporter will swap y and z values"
	ac_create_pair_label_bool $wf prefs_optimize_3ds_import "3DS optimize vertices" "remove duplicate vertices when importing 3DS files"

	ac_create_pair_label_bool $wf prefs_output_vrml_normals "Output VRML normals" \
		 "some VRML browsers calculate normals, so don't need them supplied.\nswitching this off saves on file size"
	ac_create_pair_label_bool $wf prefs_output_vrml_textures "Output VRML textures" \
		 "controls if textures and texture coordinates are generated in VRML files"

	ac_create_pair_label_bool $wf prefs_vrml1_flexsim_mode "VRML1 Flexsim mode" \
		 "if set, VRML1 exported files with any objects set to material 0 will have\ntexture coordinates, but no texture2's and no material."

	ac_create_pair_label_bool $wf prefs_vrml2_use_object_name_as_desc "VRML2 object names as desc" \
		 "specifies if the object names are used as anchor descriptions \n(objects must have a URL for an anchor to be created)"

	ac_create_pair_label_bool $wf prefs_output_rib_header "Output Renderman(.rib) header" "output world info/lights etc at start of rib file?"

	ac_create_pair_label_bool $wf prefs_rib_use_object_data "Use object data for RIB files" "Use object data in RIB (Renderman) file output"
	ac_create_pair_label_bool $wf prefs_rib_textures "Output RIB (Renderman) textures" "Output textures/UV coordinates in Renderman RIB files (untested)" 

	ac_create_pair_label_bool $wf prefs_md2_swap_yz "MD2 swap yz" "if set, MD2 importer and exporter will swap y and z values"

	ac_create_pair_label_bool $wf prefs_obj_writegroups "OBJ write groups" "if set, OBJ exporter will save objects using AC3D groups"
	ac_create_pair_label_bool $wf prefs_obj_import_as_multiple_objects "OBJ import as multiple objects" "if set, 'o <object-name> lines are used to separate the file into seperate AC3D objects.\nNote that there is no hierarchy - all objects will be on the same level."

	ac_create_pair_label_bool $wf prefs_obj_copytextures "OBJ copy textures" "if set, OBJ exporter will copy textures to the export directory"
	ac_create_pair_label_bool $wf prefs_obj_exportsubdiv "OBJ write subdivisions" "if set, OBJ exporter export any subdivided geometry"
	ac_create_pair_label_bool $wf prefs_dxf_circle_points "DXF import circle points" "the number of points in a full circle when importing DXF circles and arcs"

	ac_create_pair_label_bool $wf prefs_texture_update_tick "texture update check freq (msecs)" "how often to check loaded textures files for disk changes (set to 0 for no checking)"

#	ac_create_pair_label_bool $wf prefs_stl_swap_yz "STL change orientation" "if set, STL importer and exporter will reorient geometry from z=up/down to z=int/out"
# not needed in ASSIMP	ac_create_pair_label_bool $wf prefs_stl_import_optimize "STL Import Optimize" "if set, STL importer remove duplicate vertices when loading."
	ac_create_pair_label_bool $wf prefs_ac_file_output_hier_status "output hierarchy state in .ac files" "output hierarchy object status in AC3D files (hidden/locked/folded)"



	# MATERIALS
	ac_create_pair_label_entry_float $wm prefs_material_default_ambient "Default material ambient" "\[0.0->1.0\] default RGB component values for a new material"
	ac_create_pair_label_entry_float $wm prefs_material_default_emissive "Default material emissive" "\[0.0->1.0\] default RGB component values for a new material"
	ac_create_pair_label_entry_float $wm prefs_material_default_specular "Default material specular" "\[0.0->1.0\] default RGB component values for a new material"
	ac_create_pair_label_entry_float $wm prefs_material_default_shininess "Default material shininess" "\[0->128\] default shininess for a new material"
	ac_create_pair_label_bool $wm prefs_allow_material_rename "Enable material name editing" "if set, material names can be edited from within the\nMaterial Editor (right click on a palette button and select 'Edit...')"
	ac_create_pair_label_bool $wm prefs_export_ac3d_version_c "Export AC3D v 12 files" "AC3D 0xC files contain extra data on materials/cols.\nSwitch this off if you need to pass files to someone using an old AC3D version (pre AC3D 8).\nNote that this implicitly enables material name editing.\nThis will become the default AC3D export format in future versions of AC3D."




#	if { $tcl_platform(platform) == "windows" } {
#		# PRINTING
#		label_bool $wp prefs_printing_force_white_background "Force white background" "ignore the current 3D window bacground and put a white background on the image?" 
#		label_bool $wp prefs_printing_centre "Center the image" "Centre the image on the page?" 
#		label_bool $wp prefs_printing_scale_to_fit "Scale to fit" "Scale the image to fit the page?" 
#	}

	# ADVANCED
	ac_create_pair_label_entry_int $wad prefs_tcl_socket_port "TCL socket port" "Port number for socket AC3D's TCL socket"
	ac_create_pair_label_bool $wad prefs_allow_socket_commands "Allow socket commands" "If on, external programs can connect to AC3D and send commands to it"
#	ac_create_pair_label_bool $wad prefs_use_textures_for_background_images "Use texturing for bg images" "draw background images with texturemapping or DrawPixel"
#	ac_create_pair_label_bool $wad prefs_doublebuffer_orth "Doublebuffer orth windows" "setting this will make updating less flickery"
	ac_create_pair_label_bool $wad prefs_save_settings_on_exit "Save settings on exit" "Automatically save the settings file when you quit?"
#	ac_create_pair_label_bool $wad prefs_memory_checks "Memory Checks" "FOR DEBUGGING PURPOSES. Tracks memory and warns on freeing same address twice"
#	ac_create_pair_label_bool $wad prefs_share_opengl_contexts "Share Opengl Contexts" "Some older graphics cards have problems sharing,\nswitch this off if you have the latest drivers and are still getting blank views.\nSide effect is that you may not get textures appearing in all windows.\nNOTE THAT AC3D MUST BE RESTARTED FOR THIS SETTING TO TAKE EFFECT"
#	ac_create_pair_label_bool $wad prefs_wireframe_select_lines "Select wireframe" "in wireframe mode, select by lines rather than polygons?"
	ac_create_pair_label_bool $wad prefs_nav_select "Nav select" "if set, dragging outside the selection in 3d views will navigate (e.g. spin), rather than drag-selecting"


	ac_create_pair_label_bool $wad prefs_triangulate_quads "Triangulate quads" "If on, rendering will ensure that concave four sided polygons are drawn correctly.\nThis will be slower but gives a correct shape."

	if { $tcl_platform(platform) == "windows" } {
		ac_create_pair_label_bool $wad prefs_windows_show_console  "Show Windows console" "Keep the startup console visible? (useful for debugging purposes)"
	}

	ac_create_pair_label_bool $wad prefs_view_focus_under_mouse2 "Set focus on mouse over*" "Set the keyboard focus when the mouse pointer moves over a view\n(* = requires restart of AC3D)"

	ac_create_pair_label_bool $wad prefs_force_window_focus "Force focus*" "if set, focus of window will be forced on mouse entry.\nOn some systems this will focus AND bring the window to the front.\nSetting this is recommended for Mac users.\nAC3D must be restarted after this is changed."

	ac_create_pair_label_entry_int $wad prefs_pick_pixel_range "Pick range (pixels)" "range used for click selections\n(this should be the same as the\nvertex size if you want to select vertices by clicking)"
	ac_create_pair_label_entry_float $wad prefs_default_crease_angle "Default crease angle" "Degrees (0-180) used to form a shading crease when angles between smooth surfaces are greater than this angle.\nSetting surface to Flat forces flat shading."

	ac_create_pair_label_entry_int $wad prefs_subdivision_max_polys "Subdivision max surfaces" "Defines the maximum number of surfaces for a subdivision.\nIf an attempted subdiv may go over this level - a warning message shows.  This limit is defined because subdivision quadruples the number of surfaces at each level.\nThis increases memory requirements and reduces overall speed."

	ac_create_pair_label_spinbox $wad prefs_subdiv_max_level "Subdivision max levels" "Defines the maximum number subdivision levels possible." 2 1 6

	#ac_create_pair_label_entry_int $wad prefs_info_decimal_precision " decimal places*" "Defines the number decimal places for numbers displayed\nwithin the info box at top of the control panel (requires AC3D to be restarted)."


	# non-windows, allow slection of a web browser
	if { $ac_platform == "Linux" } {
		ac_create_pair_label_filename $wad prefs_web_browser "Web browser" "Default web browser to use when viewing web pages from AC3D"
	}


	if { $ac_platform == "Mac" } {
		ac_create_pair_label_bool $wad prefs_use_system_dialogs "Use system dialogs *" "OS X 10.4.8 introduced a bug which can cause AC3D dialogs to hang the app when they are closed.\nIf you are using 10.4.8 (or a later version), we recommend this setting is switched off.\n(requires AC3D to be restarted)"
#		ac_create_pair_label_bool $wad prefs_use_system_file_dialogs "Use system file dialogs *" "One beta tester reported a hang with file dialogs.  switch this off if you get a hang when clicking in a file dialog (requires AC3D to be restarted)"

	}

	ac_create_pair_label_bool $wad prefs_tce_is_floating "TCE is floating" "Texture Coordinate Editor is a child window of the main.\nIf this option is off, it will be a new toplevel window."
	ac_create_pair_label_bool $wad prefs_keep_windows_on_main_screen "Move windows to main screen" "If set, all windows will be forced to appear on the main screen regardless of saved position.  \nUse this after changing monitor configuration."

if { $ac_platform == "Windows" } {
	ac_create_pair_label_bool $wad prefs_spacemouse_flip_walk_mode "3D mouse flip axis for walk mode" "for 3Dconnexions devices - flip y and Z axis for walk mode in 3D views"
	ac_create_pair_label_bool $wad prefs_spacemouse_flip_spin_mode "3D mouse flip axis for spin mode" "for 3Dconnexions devices - flip y and Z axis for spin mode in 3D views"
}

	ac_create_pair_label_bool $wad prefs_sergio_ui_mode "Sergio UI*" "adds some custom buttons and icons *requires AC3D to be restarted"


	set bf [ac_frame $settings_frame.buttons]
	
	ac_button $bf.ok -text "Close" -command {
		destroy .panel
		prefs_changed
	}

	ac_button $bf.reset -text "Reset to defaults" -command {
		set answer [tk_messageBox -title "AC3D" -message "Reset all settings" \
			-icon question -type yesno \
			-detail "Are you sure you want to reset all settings to defaults?"]
		if {$answer == "no" } {break}

		destroy .panel
		ac3d prefs_set_defaults
		reset_recent_files_menu
		show_settings
	}
	pack $bf.ok -side left -pady 4
	pack $bf.reset -side right -pady 4

#	if { !$prefs_save_settings_on_exit } {
#		pack .panel.buttons.save -side right
#	}

#	 pack .panel.f -side top
	pack $bf -side bottom -expand 0

	centre_window_on_screen .panel
	wm deiconify .panel
	raise .panel

# grabbing on linux means that font dialog locks up until settings window is closed
# don't grab under linux 
# Feb 2020 - grab on tk 8.6.10 causes the whole window to lock up (widgets do not work) - removed for now

#if { $ac_platform != "Linux" } {
#    safe_grab .panel
#    tkwait window .panel
#}

}



